LISTEN	EQM $FFB1
SECOND	EQM $FF93
UNLSN	EQM $FFAE
TALK	EQM $FFB4
TKSA	EQM $FF96
UNTLK	EQM $FFAB
CIOUT	EQM $FFA8
ACPTR	EQM $FFA5
READST	EQM $FFB7

CHKIN	EQM $FFC6
CHKOUT	EQM $FFC9
CHRIN	EQM $FFCF
CHROUT	EQM $FFD2
CLALL	EQM $FFE7
CLOSE	EQM $FFC3
CLRCHN	EQM $FFCC
OPEN	EQM $FFC0
GETIN	EQM $FFE4

SETLFS	EQM $FFBA
SETNAM	EQM $FFBD

#if MACH == 264
device	EQM $AE
adrlo	EQM $03
adrhi	EQM $04
#else
device	EQM $BA
adrlo	EQM $FB
adrhi	EQM $FC
#endif

target	EQM drive+3
bank	EQM drive+4
track	EQM drive+5
sector	EQM drive+6
binflg	EQM drive+7
mirflg	EQM drive+8
pgsize	EQM drive+9
delay	EQM drive+10

        processor 6502

#if MACH == 64
	org $801
#endif
#if MACH == 20-3
	org $401
#endif
#if MACH == 20-8
	org $1201
#endif
#if MACH == 264 || MACH == 20
	org $1001
#endif
#if MACH == 128
	org $1c01

	hex 1b 08 d2 07 9e 28 c2 28 34 35 29 aa c2 28 34 
	hex 36 29 ac 32 35 36 aa 32 38 29 00 00 00
#else
	hex 1b 08 d2 07 9e 28 c2 28 34 33 29 aa c2 28 34 
	hex 34 29 ac 32 35 36 aa 32 38 29 00 00 00
#endif

	lda device
	cmp #8
	bcc dev1
	cmp #12
	bcc start 
dev1	lda #8
	sta device

start	lda #147
	jsr CHROUT
getkey	jsr status
	jsr GETIN
	cmp #'F
	bne nxt1
	lda binflg
	eor #2
	sta binflg
	jmp getkey
nxt1	cmp #'M
	bne nxt2
	lda mirflg
	eor #128
	sta mirflg
	jmp getkey

#if ULTRA == 0
nxt2	cmp #'A
	bne nxt3
	lda target
	cmp #$e0
	bne nxt9
	lda #$60
nxt9	clc
	adc #$20 
	sta target
	jmp getkey
#else
nxt2	cmp #'A
	bne nxt3
	lda target
	cmp #$a0
	bne nxt9
	lda #$20
nxt9	clc
	adc #$20 
	sta target
	jmp getkey
#endif

nxt3	cmp #'C
	bne nxt4
	lda pgsize
	bne nxt8
	lda #$20
nxt8	asl
	sta pgsize
	jmp getkey
nxt4	cmp #'S
	bne nxt5
	jsr dir
	jsr primm
#if MACH == 20 || MACH == 20-3 || MACH == 20-8
	dc.b "                    ",13,"                    ",13,145,145,0
#else
	dc.b "                                       ",13,145,0
#endif
	jsr diskerr
	jmp start
;	jmp getkey
nxt5	cmp #'Q
	bne nxt6
	jsr primm
	dc.b "BYE!",13,0
	rts
nxt6	cmp #95
	bne nxt7
	jmp start
nxt7	cmp #'B
	bne nxtb
	lda bank
	cmp #3
	bne nxta
	lda #$ff
	sta bank
nxta	inc bank
	jmp noauto

nxtb	cmp #'@
	bne nxtc
	jsr diskerr
	jmp start

nxtc	cmp #'T
	bne nxtd
	bit mirflg
	bvs noauto
	lda #0
	sta bank
	lda mirflg
	ora #$40
	sta mirflg
	bne nxtd

noauto	lda mirflg
	and #$bf
	sta mirflg

nxtd	cmp #'+
	bne nxte
	ldx device
	inx
	cpx #12
	bcc dev2
	ldx #8
dev2	stx device
	

nxte	jmp getkey
	

diskerr	jsr opencmd
	ldx #15
	jsr CHKIN

nxterr	jsr readchr
	bcs enderr
	jsr CHROUT
	bcc nxterr
enderr	jsr CLRCHN
	lda #15
	jsr CLOSE
get	jsr GETIN
	cmp #0
	beq get
	rts

dir	jsr opencmd
	ldx #15
	jsr CHKOUT
	bcc dir2
	jsr CLRCHN
	jsr CLALL
	jsr primm
	dc.b "NO DEVICE!",0
	jsr get
	pla
	pla
	jmp start

dir2	jsr primm
	dc.b "I",0
	jsr CLRCHN
	
	jsr opendir
	ldx #254
	jsr skip
	bcs end
next1	ldy #7
next2	jsr getentry
	bcs end
	ldx #2
	jsr skip
	bcs end
	dey
	bne next2
	jsr getentry
	bcc next1
end	jsr CLRCHN
	lda #2
	jsr CLOSE
	rts

getentry
	tya
	pha
	jsr readchr
	and #$80
	bne getfile
	ldx #29
	jsr skip
	pla
	tay
	rts
getfile	jsr readchr
	sta track
	jsr readchr
	sta sector
	ldx #16
next3	jsr readchr
	bcs end1
	jsr CHROUT
	dex
	bne next3 

	jsr primm
#if MACH == 20 || MACH == 20-3 || MACH == 20-8
	dc.b 13,"FLASH (",95,"/Y/N)?",13,145,145,0
#else
	dc.b " FLASH (",95,"/Y/N)?",13,145,0
#endif
	jsr CLRCHN
in	jsr GETIN
	cmp #'Y
	beq yes
	cmp #'N
	beq no
	cmp #95
	bne in
	pla
	jsr end
	sec
	rts
	
no	txa
	ldx #2
	jsr CHKIN
	ldx #11
	jsr skip
	tax
	pla
	tay
end1	rts

yes	pla
	jsr end

	ldx #15
	jsr CHKOUT
	jsr primm
	dc.b "U0",190,"M1",0
	jsr CLRCHN

	ldx #15
	jsr CHKOUT
	jsr primm
	dc.b "U0>V2",0	;syntax error on all 157x, okay on 154x
	jsr CLRCHN

	ldx #15
	jsr CHKIN
	jsr CHRIN
	cmp #$30
	beq fast
	lda #16
	dc.b $2c
fast	lda #8
	sta delay

err	jsr readchr
	bcc err
	jsr CLRCHN

	
	ldx #15
	jsr CHKOUT
	jsr primm
	dc.b "M-W",$de,4,34,0
	ldx #0
nxti	lda drivei,x
	jsr CHROUT
	inx
	cpx #34
	bne nxti
	jsr CLRCHN

	jsr openbuf

	ldx #15
	jsr CHKOUT
	jsr primm
	dc.b "B-P 2 0",0
	jsr CLRCHN

	lda #<drive
	sta adrlo
	lda #>drive
	sta adrhi
	ldx #2
	jsr CHKOUT
	ldy #0
nxt	lda (adrlo),y
	jsr CHROUT
	iny
	bne nxt
	lda #2
	jsr CLOSE
	ldx #15
	jsr CHKOUT
	jsr primm
	dc.b "U3",0
	jsr CLRCHN
	lda #15
	jsr CLOSE
	sec
	rts

nam	DC.B "$"
buf	dc.b "#2"

openbuf	lda #2
	ldy #>buf
	ldx #<buf
	jsr SETNAM
	lda #2
	ldx device
	ldy #2
	jsr SETLFS
	jsr OPEN
	rts

opencmd	lda #0
	ldy #>nam
	ldx #<nam
	jsr SETNAM
	lda #15
	ldx device
	ldy #15
	jsr SETLFS
	jsr OPEN
	rts

opendir	lda #1
	ldy #>nam
	ldx #<nam
	jsr SETNAM
	lda #2
	ldx device
	ldy #2
	jsr SETLFS
	jsr OPEN
	ldx #2
	jsr CHKIN
	rts

readchr	jsr CHRIN
	pha
	jsr READST
	clc
	bne enddir
	pla
	rts

enddir	pla
	sec
	rts

skip	jsr readchr
	bcs endskip
	dex
	bne skip
endskip	rts

primm	pha		;from C128 ROM
	txa
	pha
	tya
	pha
	ldy #0
primm1	tsx
	inc $104,x
	bne primm2
	inc $105,x
primm2	lda $104,x
	sta adrlo
	lda $105,x
	sta adrhi
	lda (adrlo),y
	beq primm3
	jsr CHROUT
	bcc primm1
primm3	pla
	tay
	pla 
	tax
	pla
	rts

status	jsr primm

#if ULTRA == 0
#if MACH == 20 || MACH == 20-3 || MACH == 20-8
	dc.b 19,"  FLASH  PROGRAMMER",13,"   FOR DISK DRIVES",13
	dc.b "(C)NICOLAS WELTE 2002",13
;	dc.b "HTTP://",13,"  PEOPLE.FREENET.DE/",13,"                 X1541"
	dc.b "   HTTP://X1541.DE",13
	dc.b "       V050104",13
;	dc.b "OPTIONS:",13
	dc.b " ",13
#else
	dc.b 19,"   FLASH PROGRAMMER FOR DISK DRIVES",13
	dc.b "       (C) NICOLAS WELTE 2002      ",13
	dc.b "          HTTP://X1541.DE        ",13
	dc.b "              V050104",13,13
;	dc.b "    HTTP://PEOPLE.FREENET.DE/X1541",13,13
	dc.b "OPTIONS:",13
#endif
#else
	dc.b 19,"    FLASH PROGRAMMER FOR ULTRADOS ",13
	dc.b    "     (C) NICOLAS WELTE 2002-2005  ",13
	dc.b    "    HTTP://X1541.DE  HTTP://D81.DE",13
	dc.b    "              V050104            ",13,13
	dc.b    "OPTIONS:",13
#endif
	dc.b 18,"F",146,"ORMAT    ",0
	lda binflg
	bne skip1
	lda #18
	jsr CHROUT
skip1	jsr primm
	dc.b "BIN",146,"/",0
	lda binflg
	cmp #2
	bne skip2
	lda #18
	jsr CHROUT
skip2	jsr primm
	dc.b "PRG",146,13

#if ULTRA == 0
	dc.b 18,"M",146,"IRROR    ",0
	lda target
	cmp #$bf
	bcs mirfix
	lda mirflg
	and #$7f
	sta mirflg
mirfix	lda mirflg
	and #128
	bne skip3
	lda #18
	jsr CHROUT
skip3	jsr primm
	dc.b "OFF",146,"/",0
	lda mirflg
	and #128
	beq skip4
	lda #18
	jsr CHROUT
skip4	jsr primm
	dc.b "ON",146,13

	dc.b 18,"A",146,"DDRESS   $",0
	lda target
	cmp #$80
	bne skp1
	jsr primm
	dc.b "8000",13,0
skp1	cmp #$a0
	bne skp2
	jsr primm
	dc.b "A000",13,0
skp2	cmp #$c0
	bne skp3
	jsr primm
	dc.b "C000",13,0
skp3	cmp #$e0
	bne skp4
	jsr primm
	dc.b "E000",13,0

skp4	jsr primm
	dc.b 18,"B",146,"ANK/AU",18,"T",146,"O ",0

	bit mirflg
	bvc norm
	jsr primm
	dc.b "AUTO",0
	bvc chip

norm	lda bank
	clc
	adc #48
	jsr CHROUT
#else
	dc.b 18,"A",146,"DDRESS   $",0
	lda target
	cmp #$40
	bne skp1
	jsr primm
	dc.b "4000",13,0
skp1	cmp #$60
	bne skp2
	jsr primm
	dc.b "6000",13,0
skp2	cmp #$80
	bne skp3
	jsr primm
	dc.b "8000",13,0
skp3	cmp #$a0
	bne chip
	jsr primm
	dc.b "A000",13,0
#endif


chip	jsr primm
	dc.b "   ",13,18,"C",146,"HIPTYPE  ",0
	lda pgsize
	bne skip5
	jsr primm
#if MACH == 20 || MACH == 20-3 || MACH == 20-8
	dc.b "29C020/040",13,0
#else
	dc.b "AT29C020/AT29C040",13,0
#endif
	beq skip7

skip5	and #$80
	beq skip6
	jsr primm
#if MACH == 20 || MACH == 20-3 || MACH == 20-8
	dc.b "29C512/010",13,0
#else
	dc.b "AT29C512/AT29C010",13,0
#endif
	bne skip7

skip6	jsr primm
#if MACH == 20 || MACH == 20-3 || MACH == 20-8
	dc.b "AT29C256  ",13,0
#else
	dc.b "AT29C256         ",13,0
#endif

skip7	jsr primm
	dc.b 18,"+",146,"DEVICE ","  ",0
	lda device
	clc
	adc #38
	cmp #48
	bcc dev3
	pha
	lda #49
	jsr CHROUT
	pla
	bne dev4
dev3	adc #10	
dev4	jsr CHROUT
	lda #32
	jsr CHROUT
	lda #13
	jsr CHROUT

	jsr primm
#if MACH == 20 || MACH == 20-3 || MACH == 20-8
	dc.b 13,18,"S",146,"ELECT FILE AND FLASH",13
#else
	dc.b 13,18,"S",146,"ELECT FILE AND START FLASHING",13
#endif
	dc.b 18,"@",146,"READ ERROR CHANNEL",13
	dc.b 18,95,146,"RESTART PROGRAM",13
	dc.b 18,"Q",146,"UIT PROGRAM",13,13,0
#if MACH == 20 || MACH == 20-3 || MACH == 20-8
	jsr primm
	dc.b 145," ",13,13,0
#endif

	rts

drive	EQM drivei+34
drivei	incbin "flash41.bin"